require 'condition_red/truthiness'
require 'bundler'
Bundler.require

module ConditionRed
end

class TrueClass
  include ConditionRed::Truthy
end

class FalseClass
  include ConditionRed::Falsey
end

class NilClass
  include ConditionRed::Falsey
  def if_nil &block
    yield
  end
end

class Object
  include ConditionRed::Truthy
  def if conditions={}
    conditions = {true: ->{}, false: ->{}, nil: ->{}}.merge conditions
    if_true(&conditions[:true]).or{if_false &conditions[:false]}.or{if_nil &conditions[:nil]}
  end
  def case cases={}
    any_case = false
    result = nil
    cases.each_pair do |key, value|
      (key==self).if true: -> do 
        any_case = true
        result = value.respond_to?(:call).if true: ->{value.call}, false: ->{value}
      end
    end
    any_case.if false: ->{
      cases[:else].nil?.if false: -> do 
        result = cases[:else].respond_to?(:call).if true: ->{cases[:else].call}, false: ->{cases[:else]}
      end
    }
    result
  end
end